#!/usr/bin/env php
<?php
	
	/**
	/* Initialisation de Zend 
	*/
	
	define('PIWIK_DOCUMENT_ROOT', '/var/www/html/piwik');
	define('PIWIK_INCLUDE_PATH', PIWIK_DOCUMENT_ROOT);

	define('PIWIK_INCLUDE_SEARCH_PATH', PIWIK_INCLUDE_PATH . '/core'
			. PATH_SEPARATOR . PIWIK_INCLUDE_PATH . '/libs'
			. PATH_SEPARATOR . PIWIK_INCLUDE_PATH . '/plugins');
		@ini_set('include_path', PIWIK_INCLUDE_SEARCH_PATH);
		@set_include_path(PIWIK_INCLUDE_SEARCH_PATH);



	require_once("Zend/Session.php");
	require_once("Zend/Http/Client.php");
	require_once("Zend/Dom/Query.php");
	
	require_once("Zend/Http/CookieJar.php");
	if(!defined('PIWIK_SESSION_NAME'))
	{
		define('PIWIK_SESSION_NAME', 'PIWIK_SESSID');
	}
	@ini_set('session.name', PIWIK_SESSION_NAME);
	Zend_Session::start();


// -*- coding: UTF-8 -*-

	/**	
	/*	permettre de forcer l'affichage en direct lors de l'exécution
	*/

	if(in_array("--help",$argv) || in_array("-h",$argv)) 
		die("option unique pour obtenir l'affichage complet, absent par défaut : -v ou -V (verbose)\n");
	elseif(in_array("-v",$argv) || in_array("-V",$argv)) $verbose = true;
	else $verbose = false;

	/**	
	/*	paramètres généraux --> obligatoires car existence vérifiée par EnvoleTools
	*/
	
	define('APPLI_NAME','piwik'); //pour affichage
	define('APPLI_MODULE','piwik'); //pour noms de fichiers ou répertoires
	define('ABSPATH','/var/www/html/'.APPLI_MODULE.'/');

	/**
	/* paramètres de connexion qui seront affectés à l'application 
	/* (DB_PASS sera généré par la librairie) 
	/* --> obligatoires car existence vérifiée par EnvoleTools
	*/
	
	define('DB_HOST','');
	define('DB_NAME','piwik');
	define('DB_USER','piwik');
	define('FILE_CONNEXION',ABSPATH.'config/config.ini.php');

	/**
	/*	classe générique qui gère les opérations utiles à l'installation
	*/
	
	if(!is_file("/usr/share/envole/".APPLI_MODULE."/EnvoleTools.class.php"))
	die("---- INSTALLATION IMPOSSIBLE ----\nCause : le fichier \"/usr/share/envole/EnvoleTools.class.php\" est introuvable. Réinstaller le paquet \"eole-piwik\".\n\n");
	require_once("/usr/share/envole/".APPLI_MODULE."/EnvoleTools.class.php");




class EnvoleToolspiwik extends EnvoleTools {

	/**
	/*	fonction à redéfinir pour chaque application et 
	/*	gérant la vérification des paramètres du fichier de connexion
	*/
	

	public function connexion_analyse()
		{
		

		if(!is_file(FILE_CONNEXION))
			{
			$this->afficher("Le fichier de connexion est introuvable... il va être recréé\n");
			$this->create_user = true;
			}
		else
			{	
			//récupération des paramètres de connexion
			//méthode de lecture reprise du fichier "calendar/includes/config.php"
		
			$this->afficher("Lecture des paramètres de connexion... ");
			
			$piwik_file = parse_ini_file(FILE_CONNEXION);
		
		
		
			//tester la validité des paramètres obtenus
		
			if($piwik_file["username"]=='')
			{
				$this->afficher("Le fichier de connexion est incomplet... il va être réécrit\n");
				$this->create_user = true;
			}else if(!$this->test($piwik_file["host"],$piwik_file["username"],$piwik_file["password"],$piwik_file["dbname"]))
			{
				$this->afficher("Les paramètres sont incorrects... ils vont être supprimer\n");
				$this->afficher( FILE_CONNEXION );
				unlink( FILE_CONNEXION );
				$this->create_user = true;
			}
		
			}
		
		}

	
}

/**
/*	démarrage réel de l'installation qui ouvre notamment 
/*	le fichier de log et récupère certaines variables du Scribe
*/

	$install = new EnvoleToolspiwik($verbose);

	$install->echo_sstitre("Analyse de la base \"".DB_NAME."\" et des paramètres de connexion");

/**
/*	vérification de la base de données
*/
	
	if($install->bdd_verification()) $install->connexion_analyse();

	/**
	/*	traitement de création éventuelle base/user
	*/
	
	$install->bdd_traitement();

	
	
	/**
	/*	sauvegarde de la base avant toute mise à jour (si la base existait déjà sinon on obtient un fichier vide...)
	*/
	
	if(!$install->create_base)
		{
		$install->echo_sstitre("Sauvegarde de la base avant toute mise à jour");
		$install->dump(DB_NAME);
		}

	/**
	/*	installation/maj par le processus propre à l'application mais automatisé dans install_appli.php
	*/
	
	$install->echo_titre("Procédure d'installation/maj propre à l'application");
	if(!is_file($install->rep_exec."install_".APPLI_MODULE.".php")) 
		$install->echec("\nLe fichier \"".$install->rep_exec."install_".APPLI_MODULE.".php\" est introuvable -> Installation interrompue.\nLe paquet aurait dû le fournir.\n\n");
	include_once($install->rep_exec."install_".APPLI_MODULE.".php");

?>
